
#ifndef __OtrDb__H__
#define __OtrDb__H__
#ifdef __cplusplus
extern "C" {
#endif

#include <stdio.h>
#include <stdlib.h>

#define OtrDbOffset(type,field) ((int)&(((type *)(0))->field))
#define OtrDbTest          0x1
#define OtrDbAutomaticKey  0x2
#define OtrDbUserKey       0x4
#define OtrDbDistributeKey 0x8

#define OtrDbUpdateAll    0x3


typedef struct {
  char *fmt;
  char *field_name;
  int  ofs;
  } OtrDbField;

typedef struct {
  char name[80];
  int  write_version;
  char comment[80];
  int  size;
  OtrDbField *f;
  int  nfield;
  } OtrDbTable;
  

	   
typedef struct {
  char *generic_servername;
  char *generic_tablename;
  char *tablename;
  int (*update)();
  int  version;
  int  major;
  int  minor;
  int  match;
  int  num_of_elements;
  int  updatebyothertable;
  } OtrDbTableStruct;
  


void  OtrDbSwitch(int i);

// Open the 'Key table'
int   OtrDbOpen();


// Define the of TableStruct object, return the number of defined ellements.
// Should be used with the 'key table' only
int   OtrDbDefine(char* server_name,char* table_name,int (*updatefcn)());

// Define the of TableStruct object, return the number of defined ellements
// Should be used  if it necessary to read selected table
int   OtrDbUserDefine(char* server_name,char* table_name,int (*updatefcn)(),\
	             int major,int minor,int match,int version);

int   OtrDbChangeServer(char *server,char *generic_table, char *newserver);

//  Set keynumber for write
int   OtrDbSetKey(char* generic_name,int major,int minor);

//  Get keynumber
int   OtrDbGetCurrentMajor();

//  To be used to update the keytable. 
int OtrDbGetTableList(int run,int time,const OtrDbTableStruct** t,int *n);

//Updates the tables contains in the key table and defined by OtrDbDefine.
int   OtrDbUpdate(int keynumber);

void* OtrDbGet(OtrDbTable* t,void *data,int* nitem);
int   OtrDbPut(const OtrDbTable* t,void *data,int nitem);

// Close the 'Key table'
int   OtrDbClose();

int   OtrDbFree();
int   OtrDbTestMe();

void OtrDbPrint(FILE* fp,OtrDbTable* tt);
int  OtrDbGetTableVersion(char *name);


#ifdef __cplusplus
}
#endif
#endif

