
#include "Otr/OtrI.h"
#include "Otr/OtrEff.h"

/* Fortran Interface */
#ifdef __cplusplus
extern "C" {
#endif
  void  OtrEffSwitch_(int* i)        { OtrEffSwitch(*i); }
  int   OtrEffInitialize_()          { return OtrEffInitialize(); }
  int   OtrEffReinitialize_()        { return OtrEffUpdate(); }
  int   OtrEffWriteToDb_()           { return OtrEffWriteToDb(); }
  int   OtrEffClose_()               { return OtrEffClose(); }
  int   OtrEffScan_()                { return OtrEffScan(0); }
  int   OtrEffPrint_()               { return OtrEffPrint(0); }
  int   OtrEffTestMe_()              { return OtrEffTestMe(); }
#ifdef __cplusplus
  }
#endif
  
static int OtrEffAlgorithm=OTRIInvalidInt;


/**
  Tasks:
    - switch between different solutions of the task of the package
  */
void  OtrEffSwitch(int i) {
  OtrEffAlgorithm=i;
  }

/**
  Tasks:
    - Memory allocation 
    - prepare for reinitialization
    - after this call reinitalization
    
  All function of the package (beside OtrEffSetAlgorithm) have to check, 
  if the initialization was done properly.
  */
  
int   OtrEffInitialize() {
  if (OtrEffAlgorithm==OTRIInvalidInt) OtrEffAlgorithm=0;
  return OTRIInvalidInt;
  }

/**
  Tasks:
    - update memory structures, arrays ... from database or ascii files 
  */
  
int   OtrEffUpdate() {
  if (OtrEffAlgorithm==OTRIInvalidInt) return OTRIInvalidInt;
  return OTRIInvalidInt;
  }
  
/**
  Tasks:
    - provide output memory structures, arrays ... to database or ascii files 
  */
int   OtrEffWriteToDb() { 
  if (OtrEffAlgorithm==OTRIInvalidInt) return OTRIInvalidInt;
  return OTRIInvalidInt;
  }

/**
  Tasks:
    - free allocate memory
    - clean up to be in a state that initialization is necessary 
  */
  
int   OtrEffClose()     { 
  if (OtrEffAlgorithm==OTRIInvalidInt) return OTRIInvalidInt;
  return OTRIInvalidInt;
  }

/**
  Tasks:
    - scan ascii files into memory structures.
    - if fp==0 assume (Fortran case), try to take filename from environment 
  */
int   OtrEffScan(FILE *fp) { 
  if (OtrEffAlgorithm==OTRIInvalidInt) return OTRIInvalidInt;
  return OTRIInvalidInt;
  }

/**
  Tasks:
    - print memory structure to ascii files
    - if fp==0 assume (Fortran case), try to take filename from environment 
  */
  
int   OtrEffPrint(FILE *fp)     { 
  if (OtrEffAlgorithm==OTRIInvalidInt) return OTRIInvalidInt;
  return OTRIInvalidInt;
  }


/**
  Tasks:
    - test bench to be sucessfully executed before any release of a new version
    - it is requested, that the author carefully thinks about testing
    - in addition it should be a collection how to test bugs, which happened
      at least once 
  */

int   OtrEffTestMe()    {
  if (OtrEffAlgorithm==OTRIInvalidInt) return OTRIInvalidInt;
  return OTRIInvalidInt;
  }
  
  
  
