
#include "Otr/OtrI.h"
#include "Otr/OtrGas.h"

/* Fortran Interface */
#ifdef __cplusplus
extern "C" {
#endif
  void  OtrGasSwitch_(int* i)        { OtrGasSwitch(*i); }
  int   OtrGasInitialize_()          { return OtrGasInitialize(); }
  int   OtrGasReinitialize_()        { return OtrGasUpdate(); }
  int   OtrGasWriteToDb_()           { return OtrGasWriteToDb(); }
  int   OtrGasClose_()               { return OtrGasClose(); }
  int   OtrGasScan_()                { return OtrGasScan(0); }
  int   OtrGasPrint_()               { return OtrGasPrint(0); }
  int   OtrGasTestMe_()              { return OtrGasTestMe(); }
#ifdef __cplusplus
  }
#endif
  
static int OtrGasAlgorithm=OTRIInvalidInt;


/**
  Tasks:
    - switch between different solutions of the task of the package
  */
void  OtrGasSwitch(int i) {
  OtrGasAlgorithm=i;
  }

/**
  Tasks:
    - Memory allocation 
    - prepare for reinitialization
    - after this call reinitalization
    
  All function of the package (beside OtrGasSetAlgorithm) have to check, 
  if the initialization was done properly.
  */
  
int   OtrGasInitialize() {
  if (OtrGasAlgorithm==OTRIInvalidInt) OtrGasAlgorithm=0;
  return OTRIInvalidInt;
  }

/**
  Tasks:
    - update memory structures, arrays ... from database or ascii files 
  */
  
int   OtrGasUpdate() {
  if (OtrGasAlgorithm==OTRIInvalidInt) return OTRIInvalidInt;
  return OTRIInvalidInt;
  }
  
/**
  Tasks:
    - provide output memory structures, arrays ... to database or ascii files 
  */
int   OtrGasWriteToDb() { 
  if (OtrGasAlgorithm==OTRIInvalidInt) return OTRIInvalidInt;
  return OTRIInvalidInt;
  }

/**
  Tasks:
    - free allocate memory
    - clean up to be in a state that initialization is necessary 
  */
  
int   OtrGasClose()     { 
  if (OtrGasAlgorithm==OTRIInvalidInt) return OTRIInvalidInt;
  return OTRIInvalidInt;
  }

/**
  Tasks:
    - scan ascii files into memory structures.
    - if fp==0 assume (Fortran case), try to take filename from environment 
  */
int   OtrGasScan(FILE *fp) { 
  if (OtrGasAlgorithm==OTRIInvalidInt) return OTRIInvalidInt;
  return OTRIInvalidInt;
  }

/**
  Tasks:
    - print memory structure to ascii files
    - if fp==0 assume (Fortran case), try to take filename from environment 
  */
  
int   OtrGasPrint(FILE *fp)     { 
  if (OtrGasAlgorithm==OTRIInvalidInt) return OTRIInvalidInt;
  return OTRIInvalidInt;
  }


/**
  Tasks:
    - test bench to be sucessfully executed before any release of a new version
    - it is requested, that the author carefully thinks about testing
    - in addition it should be a collection how to test bugs, which happened
      at least once 
  */

int   OtrGasTestMe()    {
  if (OtrGasAlgorithm==OTRIInvalidInt) return OTRIInvalidInt;
  return OTRIInvalidInt;
  }
  
  
  
