
#include "Otr/OtrI.h"
#include "Otr/OtrHv.h"

/* Fortran Interface */
#ifdef __cplusplus
extern "C" {
#endif
  void  OtrHvSwitch_(int* i)        { OtrHvSwitch(*i); }
  int   OtrHvInitialize_()          { return OtrHvInitialize(); }
  int   OtrHvReinitialize_()        { return OtrHvUpdate(); }
  int   OtrHvWriteToDb_()           { return OtrHvWriteToDb(); }
  int   OtrHvClose_()               { return OtrHvClose(); }
  int   OtrHvScan_()                { return OtrHvScan(0); }
  int   OtrHvPrint_()               { return OtrHvPrint(0); }
  int   OtrHvTestMe_()              { return OtrHvTestMe(); }
#ifdef __cplusplus
  }
#endif
  
static int OtrHvAlgorithm=OTRIInvalidInt;


/**
  Tasks:
    - switch between different solutions of the task of the package
  */
void  OtrHvSwitch(int i) {
  OtrHvAlgorithm=i;
  }

/**
  Tasks:
    - Memory allocation 
    - prepare for reinitialization
    - after this call reinitalization
    
  All function of the package (beside OtrHvSetAlgorithm) have to check, 
  if the initialization was done properly.
  */
  
int   OtrHvInitialize() {
  if (OtrHvAlgorithm==OTRIInvalidInt) OtrHvAlgorithm=0;
  return OTRIInvalidInt;
  }

/**
  Tasks:
    - update memory structures, arrays ... from database or ascii files 
  */
  
int   OtrHvUpdate() {
  if (OtrHvAlgorithm==OTRIInvalidInt) return OTRIInvalidInt;
  return OTRIInvalidInt;
  }
  
/**
  Tasks:
    - provide output memory structures, arrays ... to database or ascii files 
  */
int   OtrHvWriteToDb() { 
  if (OtrHvAlgorithm==OTRIInvalidInt) return OTRIInvalidInt;
  return OTRIInvalidInt;
  }

/**
  Tasks:
    - free allocate memory
    - clean up to be in a state that initialization is necessary 
  */
  
int   OtrHvClose()     { 
  if (OtrHvAlgorithm==OTRIInvalidInt) return OTRIInvalidInt;
  return OTRIInvalidInt;
  }

/**
  Tasks:
    - scan ascii files into memory structures.
    - if fp==0 assume (Fortran case), try to take filename from environment 
  */
int   OtrHvScan(FILE *fp) { 
  if (OtrHvAlgorithm==OTRIInvalidInt) return OTRIInvalidInt;
  return OTRIInvalidInt;
  }

/**
  Tasks:
    - print memory structure to ascii files
    - if fp==0 assume (Fortran case), try to take filename from environment 
  */
  
int   OtrHvPrint(FILE *fp)     { 
  if (OtrHvAlgorithm==OTRIInvalidInt) return OTRIInvalidInt;
  return OTRIInvalidInt;
  }


/**
  Tasks:
    - test bench to be sucessfully executed before any release of a new version
    - it is requested, that the author carefully thinks about testing
    - in addition it should be a collection how to test bugs, which happened
      at least once 
  */

int   OtrHvTestMe()    {
  if (OtrHvAlgorithm==OTRIInvalidInt) return OTRIInvalidInt;
  return OTRIInvalidInt;
  }
  
  
  
