
#include "Otr/OtrI.h"
#include "Otr/OtrLv.h"

/* Fortran Interface */
#ifdef __cplusplus
extern "C" {
#endif
  void  OtrLvSwitch_(int* i)        { OtrLvSwitch(*i); }
  int   OtrLvInitialize_()          { return OtrLvInitialize(); }
  int   OtrLvReinitialize_()        { return OtrLvUpdate(); }
  int   OtrLvWriteToDb_()           { return OtrLvWriteToDb(); }
  int   OtrLvClose_()               { return OtrLvClose(); }
  int   OtrLvScan_()                { return OtrLvScan(0); }
  int   OtrLvPrint_()               { return OtrLvPrint(0); }
  int   OtrLvTestMe_()              { return OtrLvTestMe(); }
#ifdef __cplusplus
  }
#endif
  
static int OtrLvAlgorithm=OTRIInvalidInt;


/**
  Tasks:
    - switch between different solutions of the task of the package
  */
void  OtrLvSwitch(int i) {
  OtrLvAlgorithm=i;
  }

/**
  Tasks:
    - Memory allocation 
    - prepare for reinitialization
    - after this call reinitalization
    
  All function of the package (beside OtrLvSetAlgorithm) have to check, 
  if the initialization was done properly.
  */
  
int   OtrLvInitialize() {
  if (OtrLvAlgorithm==OTRIInvalidInt) OtrLvAlgorithm=0;
  return OTRIInvalidInt;
  }

/**
  Tasks:
    - update memory structures, arrays ... from database or ascii files 
  */
  
int   OtrLvUpdate() {
  if (OtrLvAlgorithm==OTRIInvalidInt) return OTRIInvalidInt;
  return OTRIInvalidInt;
  }
  
/**
  Tasks:
    - provide output memory structures, arrays ... to database or ascii files 
  */
int   OtrLvWriteToDb() { 
  if (OtrLvAlgorithm==OTRIInvalidInt) return OTRIInvalidInt;
  return OTRIInvalidInt;
  }

/**
  Tasks:
    - free allocate memory
    - clean up to be in a state that initialization is necessary 
  */
  
int   OtrLvClose()     { 
  if (OtrLvAlgorithm==OTRIInvalidInt) return OTRIInvalidInt;
  return OTRIInvalidInt;
  }

/**
  Tasks:
    - scan ascii files into memory structures.
    - if fp==0 assume (Fortran case), try to take filename from environment 
  */
int   OtrLvScan(FILE *fp) { 
  if (OtrLvAlgorithm==OTRIInvalidInt) return OTRIInvalidInt;
  return OTRIInvalidInt;
  }

/**
  Tasks:
    - print memory structure to ascii files
    - if fp==0 assume (Fortran case), try to take filename from environment 
  */
  
int   OtrLvPrint(FILE *fp)     { 
  if (OtrLvAlgorithm==OTRIInvalidInt) return OTRIInvalidInt;
  return OTRIInvalidInt;
  }


/**
  Tasks:
    - test bench to be sucessfully executed before any release of a new version
    - it is requested, that the author carefully thinks about testing
    - in addition it should be a collection how to test bugs, which happened
      at least once 
  */

int   OtrLvTestMe()    {
  if (OtrLvAlgorithm==OTRIInvalidInt) return OTRIInvalidInt;
  return OTRIInvalidInt;
  }
  
  
  
