#include "Otr/OtrRt.h"
#include "Otr/OtrI.h"
#include "wax/RTManager.hh"
#include "wax/RTRelation.hh"
#include <stdiostream.h>

//#include "Otr/OtrRt.h"
//#include "Otr/OtrI.h"

/* -------------------------------------------------------------------- */

// int OtrRtUpdate() {
//   if (OtrIDbIsOpen()) {
//     }
//   else {
//     char* fname=getenv("OtrRtInput");
//     if (fname) {
//       int ret;
      
//       FILE *fp=fopen(fname,"r");
//       if (!fp) {
//         return OtrIErrorMsg(OTRIInvalid,"OtrRtUpdate",
//                             "Cannot open file",fname);
//         }
//       OtrRtScan(fp);
//       return ret;
//       }
//     }  
//   return 0;
//   };


int OtrRtInitialize() {
  waxRTManager::GetMe() ;
  return 0;
} ;

int OtrRtUpdate() {
  waxRTManager::GetMe()->ReadDB() ;
  return 0;
}

int OtrRtWriteToDb() {
  waxRTManager::GetMe()->WriteDB() ;
  return 0;
}

int OtrRtClose() {
  waxRTManager::DeleteMe() ;
  return 0;
}

int OtrRtScan(FILE *fp) {
  // Both of these compile. One of them should work :)
  streambuf* strbuf = static_cast<streambuf*>(fp) ;
  istream is(strbuf);

  stdiobuf strbuf2(fp) ;
  istream is2(&strbuf2);
  //istdiostream is1(strbuf) ;
  waxRTManager::GetMe()->ReadAll(is2) ;
  return 0;
}

int OtrRtPrint(FILE *fp) {
  streambuf* strbuf = static_cast<streambuf*>(fp) ;
  ostream os(strbuf);
  waxRTManager::GetMe()->WriteAll(os) ;
  return 0;
}

int OtrRtTestMe() {
  waxRTManager::GetMe()->Dump() ;
  return 0;
}

// These routines are not as slow as they look like: There are no
// underlying function calls.

float OtrRtRadius(int ci, float t) 
{
  return waxRTManager::GetUncheckedMe()->
    GetRTRelationFromGedeIndex(OtrIGeoIndex(ci))->
    GetRTResultFromT(t).fR ;
}

float OtrRtRadiusError(int ci,float t) 
{
  return waxRTManager::GetUncheckedMe()->
    GetRTRelationFromGedeIndex(OtrIGeoIndex(ci))->
    GetRTResultFromT(t).fSigmaR ;
}

// I think this is the best one for the hitpreparation:
void OtrRtRadiusAndError(int ci, float t, float *r, float *s)
{
  waxRTManager::GetUncheckedMe()->
    GetRTRelationFromGedeIndex(OtrIGeoIndex(ci))->
    ProcessTime(t,r,s) ;
}

float OtrRtTime(int ci,float r)
{
  return waxRTManager::GetUncheckedMe()->
    GetRTRelationFromGedeIndex(OtrIGeoIndex(ci))->
    GetRTResultFromR(r).fT ;
}

float OtrRtTimeError(int ci,float r) 
{
  waxRTRelation::RTResult rtresult = 
    waxRTManager::GetUncheckedMe()->
    GetRTRelationFromGedeIndex(OtrIGeoIndex(ci))->
    GetRTResultFromR(r) ;
  return rtresult.fSigmaR*rtresult.fdTdR ;
}

