#include <string>
#include <fstream>
#include <iomanip>
#include "wax/RTRelation.hh"
#include "wax/RTManager.hh"
//#include "wax/otr_db.h"

#ifdef USE_ARTE
//#include "wax/GedeManager.hh"
//#include "wax/Gede.hh"
#include "arte/ArteFlag.h"
#include "arte/arte.hh"
#else
#include "Otr/OtrGeo.h"
#endif

waxRTManager* waxRTManager::fgMe = 0;
int waxRTManager::fgSwitch = 0;

std::string 
waxRTManager::fgConfigDirName = "" ;

waxRTManager* waxRTManager::GetMe()
{
  if(!fgMe) fgMe = new waxRTManager() ;
  return fgMe ;
}

void waxRTManager::DeleteMe() 
{
  delete fgMe ;
  fgMe=0;
}

waxRTManager::~waxRTManager() 
{
  if(fgMe == this) fgMe = 0;
}

void
waxRTManager::ReadDB()
{  
  std::cout << "*------------------------------------------------*" << std::endl
	    << "* waxRTManager: reading rt-relations from DB    *" << std::endl ;

//   // first find max index
//   int max_irt(0) ;
//   int min_irt(1000) ;
//   for(LedaTableIterator<class OTR_r_t> 
// 	ledartIt = LedaTableIterator<class OTR_r_t>();
//       ledartIt.valid(); ledartIt.next()) {
//     max_irt=max(max_irt,ledartIt->irt) ;
//     min_irt=min(min_irt,ledartIt->irt) ;
//   }
//   std::cout << min_irt << " " << max_irt << std::endl ;

//   // now read rt-relation
//   fRTRelations.resize(max_irt-min_irt,0) ;
//   fRTIndexMin = min_irt ;
//   for(LedaTableIterator<class OTR_r_t> 
// 	ledartIt = LedaTableIterator<class OTR_r_t>();
//       ledartIt.valid(); ledartIt.next()) {
//     RTContainer::iterator rtIt = fRTRelations.begin()
//       +(ledartIt->irt-fRTIndexMin) ;
//     if(!(*rtIt)) *rtIt = new waxRTRelation(ledartIt) ;
//     else (*rtIt)->ReadDB() ;
//   }

// #ifdef USE_ARTE
//   // last but not least: set pointer of gede to rtrelation
//   for(waxGedeManager::GedeContainer::iterator
// 	gedeIt=waxGedeManager::GetMe()->GetGedes().begin() ;
//       gedeIt!=waxGedeManager::GetMe()->GetGedes().end() ; gedeIt++)
//     if(*gedeIt) {
//       LedaPointer<class OTR_nede> ledaNedeIt(OTR_nede->get->key((*gedeIt)->GetHWC())) ;
//       LedaPointer<class OTR_r_t>  ledaRtIt(ledaNedeIt->tor_t) ;
//       waxRTRelation* rtr = GetRTRelation(ledaRtIt->irt) ;
//       (*gedeIt)->SetRTRelation(rtr) ;
//       if(!rtr) std::cout << "Could not find rt relation in db !" << std::endl ;
//     }
// #endif USE_ARTE
}

void
waxRTManager::WriteDB()
{
  std::cout << "waxRTManager::WriteDB()" << std::endl ;
  //OTR_r_t->initialize();
  //std::cout << "OTR_r_t initialized ..." << std::endl ;

  // Write dsrs
  //   for(RTContainer::const_iterator dsrIt = fRTRelations.begin();
  //       dsrIt != fRTRelations.end(); dsrIt++) 
  //     (*dsrIt)->WriteDB() ;
  // Write relation to nede
  //   for(waxGedeManager::GedeContainer::const_iterator
  // 	gedeIt=fGedeManager->GetGedes().begin() ;
  //       gedeIt!=fGedeManager->GetGedes().end() ; gedeIt++)
  //     if(*gedeIt) {
  //       RelateRows(OTR_nede,tor_t,  key((*gedeIt)->GetGEDE()->hwc),
  // 		 OTR_r_t, tonede, key((*gedeIt)->GetRTRelation()->GetLedaKey()) );
  //     }
  std::cout << "End of waxRTManager::WriteDB()" << std::endl ; 
}

// void
// waxRTManager::FillOTTS()
// {
// }

void
waxRTManager::ReadGeoToRtMap(istream& ifs)
{
  // First find min and max otr gedeid
  fMinGedeId = 10000;
  unsigned int maxGedeId = 0;
#ifdef USE_ARTE
  for(ArteTable<GEDE>::iterator gedeIt = ArteTable<GEDE>::begin() ;
      gedeIt != ArteTable<GEDE>::end() ; gedeIt++)
    if(gedeIt->cmp==2) {
      if(fMinGedeId>gedeIt.index()) fMinGedeId = gedeIt.index();
      if(maxGedeId<gedeIt.index()) maxGedeId = gedeIt.index();
    }
#else
  if(OtrGeoInitialize()==0) {
   for(unsigned int gi=0; 
       gi<(unsigned int)(OtrGeoNumberOfVolumes()); gi++) 
     if(OtrGeoGet(gi)->cmp==2) {
       if(fMinGedeId>gi) fMinGedeId = gi ;
       if(maxGedeId<gi)   maxGedeId = gi ;
     }
  } else {
    cout << "waxRTManager: Could not initialize geometry ==>" << endl
	 << "Relation between geo and rt not set." << endl ;
    return;
  }
#endif
  
  // allocate space in map and set every rtindex to 0
  fGeoToRTMap.resize(maxGedeId-fMinGedeId+1,0) ;

  // now read info from the file
  //string geoname;
  int rtid,rtid10mm ;
  char geoname[16];
  char line[256];

  while(ifs) {
    ifs.getline(line,256) ;
    if(line[0]!='#' && strlen(line)>1) {
      sscanf(line,"%s %d %d",geoname,&rtid,&rtid10mm) ;
      bool isAbbrev = (strlen(geoname)<11) ;
      //if(isAbbrev) ifs >> rtid10mm;
      // search for all otrgedes that match geoname
#ifdef USE_ARTE
      for(ArteTable<GEDE>::iterator gedeIt = ArteTable<GEDE>::begin() ;
	  gedeIt != ArteTable<GEDE>::end() ; gedeIt++)
	if(gedeIt->cmp==2 && !strncmp(gedeIt->hwc,geoname,strlen(geoname))) {
	  if(isAbbrev && gedeIt->pit>1)
	    fGeoToRTMap[gedeIt.index() - fMinGedeId] = rtid10mm;
	  else
	    fGeoToRTMap[gedeIt.index() - fMinGedeId] = rtid ;	  
	}
#else
      for(int gi=0; gi<OtrGeoNumberOfVolumes(); gi++) 
	if(OtrGeoGet(gi)->cmp==2 && 
	   !strncmp(OtrGeoGet(gi)->hwc,geoname,strlen(geoname))) {
	  if(isAbbrev && OtrGeoGet(gi)->pit>1)
	    fGeoToRTMap[gi - fMinGedeId] = rtid10mm;
	  else
	    fGeoToRTMap[gi - fMinGedeId] = rtid ;	  
	}
#endif
    }
  }
  
#ifdef USE_ARTE
  // now check that all gedes are matched to an existing rt-relation:
  for(ArteTable<GEDE>::iterator gedeIt = ArteTable<GEDE>::begin() ;
      gedeIt != ArteTable<GEDE>::end() ; gedeIt++)
    if(gedeIt->cmp==2 && gedeIt->sec>0 &&
       GetRTRelation(fGeoToRTMap[gedeIt.index() - fMinGedeId])==0) {
      char name[13] ;
      strncpy(name,gedeIt->hwc,12) ;
      name[12] = '\0' ;
      std::cout << "* Problem in wax: No valid rt-relation for gede " 
		<< name << " " 
		<< int(fGeoToRTMap[gedeIt.index() - fMinGedeId])<< std::endl ;
    }
#endif
}

waxRTManager::waxRTManager() 
  : fRTRelations(0)
{
  // This routine is still a terrible hack, but since the database is
  // soon finished, it all doesn;t matter too much anyway.
  
  string dirname = "/afs/desy.de/group/hera-b/OTR/db/dsr/run11306" ;
  
  //#ifdef __WAX_DEBUG__
  std::cout << "* Reading rt-relations:" << std::endl ;
  //#endif
  fgMe = this ;
  
  // Read all rt-relations in this directory
  fRTIndexMin=1;
  int maxrtid=10;
  fRTRelations.resize(maxrtid,0) ;
  char filename[256];
  ifstream ifs ;
  for(int i=1; i<maxrtid; i++) {
    sprintf(filename,"%s/rtr%2.2d.dat",dirname.c_str(),i) ;
    ifs.open(filename) ;
    if(ifs) {
      fRTRelations[i-fRTIndexMin] = new waxRTRelation(i,ifs) ;
      ifs.close() ;
      cout << filename << endl ;
    }
  }

  // Last create map from gedeindex to rtindex
  sprintf(filename,"%s/geotort.txt",dirname.c_str()) ;
  ifs.open(filename) ;
  if(ifs) ReadGeoToRtMap(ifs) ;
  else cout << "Could not find " << filename << endl ;
  ifs.close() ;
}

void waxRTManager::Dump() const
{
  std::cout << "*------------------------------------------------*" << std::endl
	    << "* waxRTManager: testing                         *" << std::endl
	    << "*                                                *" << std::endl
	    << "* Number of rt-relations: " << fRTRelations.size() << std::endl ;
  for(RTContainer::const_iterator dsrIt = fRTRelations.begin();
      dsrIt != fRTRelations.end(); dsrIt++) {
    std::cout << "* rti,tmin,tmax,rmin,rmax: " 
	      << std::setw(10) << std::setprecision(3) << (*dsrIt)->GetRTIndex()
	      << std::setw(10) << std::setprecision(3) << (*dsrIt)->GetTMin()
	      << std::setw(10) << std::setprecision(3) << (*dsrIt)->GetTMax()
	      << std::setw(10) << std::setprecision(3) << (*dsrIt)->GetRMin()
	      << std::setw(10) << std::setprecision(3) << (*dsrIt)->GetRMax() 
	      << std::endl ;
  }
  std::cout << "*------------------------------------------------*" << std::endl ;
}

void waxRTManager::WriteAll(ostream& os, int format) const
{
  cout << "waxRTManager::WriteAll(..) needs some more thinking:" << endl 
       << "there is no relation to the geometry yet."
       << endl ;
  for(RTContainer::const_iterator rtIt= fRTRelations.begin() ;
      rtIt != fRTRelations.end() ; ++rtIt) {
    os << "RtRelation " << (*rtIt)->GetRTIndex() << endl ;
    (*rtIt)->Write(format,os) ;
  }
}

void waxRTManager::ReadAll(istream& is)
{
  cout << "waxRTManager::ReadAll(..) needs some more thinking:" << endl 
       << "there is no relation to the geometry yet." 
       << endl ;
  for(RTContainer::const_iterator rtIt= fRTRelations.begin() ;
      rtIt != fRTRelations.end() ; ++rtIt) {
    char line[256];
    is.getline(line,256) ;
    if(!strncmp(line,"RtRelation",10)) {
      unsigned int index = atoi(line+12) ;
      // check if this rtrelation is there
      if(index >= fRTRelations.size()) fRTRelations.resize(index+1) ;
      fRTRelations[index]->Read(is) ;
    }
  }
}
